function regJ
Tmax=120;
acc=0.0003;
hmin=200; hh=25; hmax=1300;% 
%kmin=1; hk=10; kmax=45;
n=1;
options = odeset('RelTol', 3e-5); % 
c0=[0 0 0 1 0.365 0.365 -0.095];% 
c0(4)=sqrt(1-c0(5)^2-c0(6)^2-c0(7)^2);% -  
%cT=[0 0 0 1 0 0 0]; % 
I1=100;     I2=180;     I3=150; %  
r1=1;       r2=1;       r3=1;   % 
umax=0.45; %      
I32=I3-I2; I13=I1-I3; I21=I2-I1;
figure;
set(gcf,'Color',[1 1 1],'Units','centimeters',...
        'Position',[1 1 15 15]);
plot(0,0,'.');grid on;hold on;%drawnow;
clc;
disp('   - ');
disp(Tmax);
tic;
k1=I1; k2=I2; k3=I3; % 
for h1 = hmin : hh : hmax,
for h2 = hmin : hh : hmax,
for h3 = hmin : hh : hmax,
%   for k1 = kmin : hk : kmax,
%   for k2 = kmin : hk : kmax,
%   for k3 = kmin : hk : kmax,
        disp([h1 h2 h3]); 
        k = [ h1 k1 ... 
              h2 k2 ...
              h3 k3 ];
        [tt,yy]=ode45(@model,[0 Tmax],c0,options,k);%  
        tTG=criterions(tt,yy,k);
        if tTG(1)~=-1,
            T(n,1)=tTG(1); G(n,1)=tTG(2);
            K(n,1:6)=k(1:6);
            %plot(T(n),G(n),'.');grid on;hold on;drawnow;
            n=n+1;
        end
%   end
%   end
%   end
end
end
end
timeS=toc;
plot(T,G,'.');grid on;
% 
save region T G K timeS;
disp('  :');
disp(timeS);
disp('!');

    function dydt = model(t,y,kk) 
        u1=-kk(1)*y(1)-kk(2)*y(4)*y(5);
        u2=-kk(3)*y(2)-kk(4)*y(4)*y(6);
        u3=-kk(5)*y(3)-kk(6)*y(4)*y(7);
        if abs(u1)>umax, u1=umax*sign(u1); end
        if abs(u2)>umax, u2=umax*sign(u2); end
        if abs(u3)>umax, u3=umax*sign(u3); end
        dydt = [ (u1-I32*y(2)*y(3))/I1
                 (u2-I13*y(1)*y(3))/I2
                 (u3-I21*y(1)*y(2))/I3
                 (-y(5)*y(1)-y(6)*y(2)-y(7)*y(3))/2
                 (y(4)*y(1)+y(6)*y(3)-y(7)*y(2))/2
                 (y(4)*y(2)+y(7)*y(1)-y(5)*y(3))/2
                 (y(4)*y(3)+y(5)*y(2)-y(6)*y(1))/2 ];
    end

    function uu = kpzU(y,kk)
        u1=-kk(1)*y(1)-kk(2)*y(4)*y(5);
        u2=-kk(3)*y(2)-kk(4)*y(4)*y(6);
        u3=-kk(5)*y(3)-kk(6)*y(4)*y(7);
        if abs(u1)>umax, u1=umax*sign(u1); end
        if abs(u2)>umax, u2=umax*sign(u2); end
        if abs(u3)>umax, u3=umax*sign(u3); end
        %if abs(u1)<umin, u1=0; end;
        %if abs(u2)<umin, u2=0; end;
        %if abs(u3)<umin, u3=0; end;
        uu = [ u1
               u2
               u3 ];
    end

    function upr = fU(t,y,kk)
        imax=length(t);
        fu1 = zeros (1,imax);
        fu2 = zeros (1,imax);
        fu3 = zeros (1,imax);
        for i=1:imax,
            u = kpzU(y(i,:),kk);
            fu1(i) = u(1);
            fu2(i) = u(2);
            fu3(i) = u(3);
        end;
        upr = [ fu1(:) fu2(:) fu3(:) ];
    end

    function plotF(t,y,kk)
        figure;
        % 
        subplot(4,2,1);
        plot(t,y(:,1));grid on;
        title('w1(t)');

        subplot(4,2,3);
        plot(t,y(:,2));grid on;
        title('w2(t)');

        subplot(4,2,5);
        plot(t,y(:,3));grid on;
        title('w3(t)');

        subplot(4,2,2);
        plot(t,y(:,1+4));grid on;
        title('l1(t)');

        subplot(4,2,4);
        plot(t,y(:,2+4));grid on;
        title('l2(t)');

        subplot(4,2,6);
        plot(t,y(:,3+4));grid on;
        title('l3(t)');

        subplot(4,2,8);
        plot(t,y(:,4));grid on;
        title('l0(t)');

        %disp(y(length(t),:));
        
        uu = fU(t,y,kk);
        uu1=uu(:,1); uu2=uu(:,2); uu3=uu(:,3);

        figure;
        subplot(3,1,1);
        plot(t,uu1(:));grid on;
        subplot(3,1,2);
        plot(t,uu2(:));grid on;
        subplot(3,1,3);
        plot(t,uu3(:));grid on;
    end 

    function TG = criterions(t,y,k)
        imax=length(t);
        intube=false;
        for i=1:imax,
            e = [ y(i,1)
                  y(i,2)
                  y(i,3)
                  2*y(i,4)*y(i,5)
                  2*y(i,4)*y(i,6)
                  2*y(i,4)*y(i,7) ];
            emax=max(e);
            if and(emax<=acc,intube==false), intube=true; iTp=i; end
            if emax>acc, intube=false; end
        end %for
        if intube==true,
            up=fU(t,y,k);
            TG = [ t(iTp) 
                   trapz(t(1:iTp),abs(up(1:iTp,1))/r1+abs(up(1:iTp,2))/r2+abs(up(1:iTp,3))/r3) ];
        else
            TG = [ -1 -1 ];
        end %if
    end

end